#include <iostream>
#include <fstream>
#include <list>
#include "darbas.h"
#include "grupe.h"
#include "groupList.h"
using namespace std;

//------------------------------------------------------------
GroupList::~GroupList()
{
   list<Group*>::iterator vi;
   for (vi = groupList.begin();  vi != groupList.end();  vi++)
       delete (*vi);              // delete Group objektus
       groupList.clear();      // delete Group nuorodas (pointers)
}
//------------------------------------------------------------
void GroupList::printSarasa() {
   cout << "====================================================" << endl;
   groupList.sort(Palyginti());
   list<Group*>::iterator vi = groupList.begin();

   for (;  vi != groupList.end();  vi++)
      (*vi)->printGroup();
   cout << "====================================================" << endl;
}
//------------------------------------------------------------
void GroupList::iSarasa(std::string grupe, std::string name, std::string date)
{
  list<Group*>::iterator i=groupList.begin();
  while((i!=groupList.end())&&((*i)->getGrupe()!=grupe))
    i++;
  if(i==groupList.end())
  {
    Group* g=new Group(grupe);
    g->iSarasa(name, date);
    groupList.push_back(g);
  }
  else
    (*i)->iSarasa(name, date);
}
//------------------------------------------------------------
void GroupList::addToSarasas() {
   string grupe;
   string name;
   string data;
   cout << "Kuriai GRUPEI priskirti nauja irasa: ";
   cin >> grupe;
   cout << "Atlikto darbo pavadinimas: ";
   cin >> name;
   cout << "Data (MMMM-mm-dd): ";
   cin >> data;
   list<Group*>::iterator iter = groupList.begin();
      for (;  iter != groupList.end();  iter++) {
      string grupeX = (*iter)->getGrupe();
         if (grupeX == grupe) {
            (*iter)->iSarasa(name,data);
            break;
         }
      }
}
//------------------------------------------------------------
void GroupList::createNewGroup() {
   string grupe;
   cout << "Kaip vadinsis nauja GRUPE : ";
   cin >> grupe;
   groupList.push_back(new Group(grupe));
}
//------------------------------------------------------------
void GroupList::printLaikotarpi() {
   string dataNuo;
   string dataIki;
   cout << "Nuo kada (MMMM-mm-dd): ";
   cin >> dataNuo;
   cout << "Iki kada (MMMM-mm-dd): ";
   cin >> dataIki;
   list<Group*>::iterator iter = groupList.begin();
   for (;  iter != groupList.end();  iter++)
      (*iter)->printGroupPagalLaika(dataNuo, dataIki);
}
//------------------------------------------------------------
void GroupList::printVienaSarasa(){
   string grupe;
   cout << "Kurios GRUPES spausdinti darbu sarasa: ";
   cin >> grupe;
   list<Group*>::iterator iter = groupList.begin();
   for (;  iter != groupList.end();  iter++) {
      string grupeX = (*iter)->getGrupe();
      if (grupeX == grupe)
         (*iter)->printGroup();
   }
}
//-------------------------------------------------------------
void GroupList::iFaila() {
   ofstream failas("output.txt");
   groupList.sort(Palyginti());
   list<Group*>::iterator vi = groupList.begin();
   for (;  vi != groupList.end();  vi++)
      (*vi)->printGroupToFile(failas);
   failas.close();
      
  /*failas<<autoVardas<<endl;
  failas<<nuomosSutartys.size()<<endl;
  list<NuomosSutartis*>::iterator i=nuomosSutartys.begin();
  for(; i!=nuomosSutartys.end(); i++)
    (*i)->iFaila(failas);*/
}