#include <iostream>
#include <list>
#include "darbas.h"
#include "grupe.h"

using namespace std;
//------------------------------------------------------------
Group::Group(std::string grupe)
{
  this->grupe=grupe;
}
//------------------------------------------------------------
Group::~Group()
{
  list<Darbas*>::iterator i;
   for (i = darbai.begin();  i != darbai.end();  i++)
       delete (*i);
       darbai.clear();
}
//------------------------------------------------------------
string Group::getGrupe()
{
  return(grupe);
}
//------------------------------------------------------------
void Group::printGroup()
{
  cout<<grupe<<":"<<endl;
  list<Darbas*>::iterator i=darbai.begin();
  for(; i!=darbai.end(); i++)
     cout<<"   "<<(*i)->getName()<<", "<<(*i)->getDate()<<endl;
  cout<<endl;
}
//------------------------------------------------------------
void Group::printGroupToFile(std::ofstream& failas)
{
  failas<<grupe<<":"<<endl;
  list<Darbas*>::iterator i=darbai.begin();
  for(; i!=darbai.end(); i++)
     failas<<"   "<<(*i)->getName()<<"\t "<<(*i)->getDate()<<endl;
  //cout<<endl;
}
//------------------------------------------------------------
void Group::printGroupPagalLaika(std::string nuo, std::string iki)
{
  cout<<grupe<<":"<<endl;
  list<Darbas*>::iterator i=darbai.begin();
  for(; i!=darbai.end(); i++)
     if((nuo <= (*i)->getDate()) && ((*i)->getDate() <= iki))
        cout<<"   "<<(*i)->getDate()<<" - "<<(*i)->getName()<<endl;
  cout<<endl;
}
//------------------------------------------------------------
void Group::iSarasa(std::string name, std::string date)
{
  darbai.push_back(new Darbas(name, date));
}
