
TARGET=main.exe

compile: $(TARGET)

run: compile
	$(TARGET)

main.exe       : main.o darbas.o grupe.o groupList.o
main.o          : main.cpp darbas.h grupe.h groupList.h
darbas.o       : darbas.cpp darbas.h
grupe.o        : grupe.cpp grupe.h darbas.h
groupList.o   : groupList.cpp groupList.h darbas.h grupe.h

#-------------------------------------------------------------

clean:
	rm -f *.o
	rm -f *.exe

build: clean compile

%.exe: %.o
	g++ -o $@ $^
	
%.o: %.cpp
	g++ -c $<

#=============================================================#
